diff -Naur channels/chan_sip.c channels.NEW/chan_sip.c
--- channels/chan_sip.c 2005-01-25 16:57:29.000000000 -0500
+++ channels.NEW/chan_sip.c     2005-01-25 17:39:40.000000000 -0500
@@ -4204,7 +4204,14 @@
                }
                /* Find address to hostname */
                if (create_addr(p,r->hostname)) {
-                       sip_destroy(p);
+                        /* we have what we hope is a temporary network error,
+                         * probably DNS.  We need to reschedule a registration try */
+                        sip_destroy(p);
+                        if (r->timeout > -1) {
+                                ast_log(LOG_WARNING, "Still have a registration timeout (create_addr() error), %d\n", r->timeout);
+                                ast_sched_del(sched, r->timeout);
+                        }
+                        r->timeout = ast_sched_add(sched, 20*1000, sip_reg_timeout, r);
                        return 0;
                }
